/*	CUT save	*/
/*	1998 Rick	*/

#include	<corlib.h>
#include	<string.h>
#include	<sys_doslib.h>

int cutwsave( char*, Sheet* );
int cutsave( char*, Sheet* );
int cutwrite( int, Sheet*, int );
void numwrite( char*, int );

int
cutwsave( fname, bufp )
char *fname;
Sheet *bufp;
{
	int fn= 0, size;
	unsigned char headbuf[52]= "CUT_V1.0(0000,0000)Ko-window cutw.win 0.4\r\n\x1a\0\0\0\0";
	unsigned char *tmpchr;

	if( (fn= CREATE( fname, 0 ) )<0 )
		return 1;
	numwrite( headbuf+12, bufp->h );
	numwrite( headbuf+17, bufp->v );

	tmpchr= headbuf+48;
	*tmpchr++= bufp->h>>8;
	*tmpchr++= bufp->h & 0xff;
	*tmpchr++= bufp->v >> 8;
	*tmpchr= bufp->v & 0xff;

	WRITE( fn, headbuf, 52 );

	cutwrite( fn, bufp, 0 );
	
	size= SEEK( fn, 0, 1 );

	tmpchr= headbuf+41;
	*tmpchr++= ' ';
	*tmpchr++= ' ';
	*tmpchr++= ' ';
	*tmpchr++= '\r';
	*tmpchr++= '\n';
	*tmpchr= '\x1a';

	WRITE( fn, headbuf, 52 );

	cutwrite( fn, bufp, 1 );

	SEEK( fn, 44, 0 );
	tmpchr= headbuf;
	*tmpchr++= size>>24;
	*tmpchr++= size>>16;
	*tmpchr++= size>>8; 
	*tmpchr= size & 0xff;
	WRITE( fn, headbuf, 4 );
	CLOSE( fn );
	return 0;
}

int
cutsave( fname, bufp )
char *fname;
Sheet *bufp;
{
	int fn= 0;
	unsigned char headbuf[52]= "CUT_V1.0(0000,0000)Ko-window cutw.win 0.4    \r\n\x1a";
	unsigned char *tmpchr;

	if( (fn= CREATE( fname, 0 ) )<0 )
		return 1;
	numwrite( headbuf+12, bufp->h );
	numwrite( headbuf+17, bufp->v );

	tmpchr= headbuf+48;
	*tmpchr++= bufp->h>>8;
	*tmpchr++= bufp->h & 0xff;
	*tmpchr++= bufp->v >> 8;
	*tmpchr= bufp->v & 0xff;

	WRITE( fn, headbuf, 52 );

	cutwrite( fn, bufp, 0 );
	
	CLOSE( fn );
	return 0;
}

int
cutwrite( fn, bufp, plane )
int fn;
Sheet *bufp;
int plane;
{
	short	yline, xbyte, headsize, bodysize, bitcount;
	int oddflg= FALSE;
	unsigned char writebuf[146];
	unsigned char *prev, *head, *body, *readbyte, *prevline,
					dat, state, writecount;

	bodysize= (bufp->h+7)>>3;
	if( bodysize & 1 )
		oddflg= TRUE;
	headsize= (bodysize+7)>>3;
	prev= writebuf+17;
	for( xbyte= 0; xbyte< bodysize; xbyte++ ){
		*prev++= 0;
	}
	
	if( !plane ){
		readbyte= (char*)(bufp->buf1);
	}else {
		readbyte= (char*)(bufp->buf2);
	}
	prevline= writebuf+17;
	for( yline= 0; yline< bufp->v; yline++ ){
		prev= prevline;
		prevline= readbyte;
		head= writebuf+1;
		body= head+headsize;
		bitcount= 0;
		state= 0;
		for( xbyte= 0; xbyte< bodysize; xbyte++ ){
			dat= (*readbyte++) ^ *prev++;
			if( dat ){
				state |= 1;
				*body++= dat;
			}
			if( ++bitcount >7 ){
				*head++= state;
				state= 0;
				bitcount= 0;
			}else
				state= state<<1;
		}
		if( bitcount )
			*head++= state << ( 7 - bitcount );
		if( !(writecount= (int)(body - head ) ) ){
			FPUTC( 1, fn );
		}else{
			writecount += headsize + 1;
			*writebuf= writecount;
			WRITE( fn, writebuf, writecount );
		}
		if( oddflg )
			readbyte++;
	}
	return 0;
}

void
numwrite( buf, num )
char	*buf;
int	num;
{
	char	*tmp= buf;
	int	i, j;

	i= num;

	while( i ){
		j= i % 10;
		i/= 10;
		
		*tmp--= (char)(j+48);
	}
	return;
}
