/*	ngv_save.win	ver0.30	*/
/*	 Aug. 24 1998  by Rick	*/

#include	<corlib.h>
#include	<winop.h>

#define		PROG		"gv_save"
#define		XSIZE		(60)
#define		YSIZE		(30-12)


int WindowHeapSize= 1024 * 0;
WindowID	cwp= NULL;

extern int	inpopen( EventInfo* );

static int
EventExec( wp, info )
WindowID	wp;
EventInfo	*info;
{
	DrawBuf	dbuf[4];
	switch( info->option ){
		case EventOpen:
			WindowSetEventAttr( wp,  EventOpenON|EventRedrawON
				|EventCloseON|EventMouseSwitchON|EventUserON );
			WindowRedraw( wp );
			return	TRUE;
		case EventRedraw:
			DrawSetClear( dbuf, ColorGray );
			DrawSetSymbol( dbuf+1, 8, 1, PROG, 9|4, 12 );
			WindowDraw( wp, dbuf, 2 );
/*			if( cwp )	WindowRedraw( cwp );*/
			return	TRUE;
		case EventClose:
			if( cwp )	WindowClose( cwp );
			WindowClose( wp );
			WindowConnectionClose();
			return	TRUE;

		case EventUser:
			if( cwp )	return FALSE;
			inpopen( info );
			return	TRUE;

		case EventMouseSwitch:
			if( info->LeftON ){
				ConsoleOpen();
				ConsolePrint(
"\r\n" PROG " 1998 Rick\r\n"
"----------------------------------------------------------------\r\n"
"̃EBhE UserGraphic ܂ UserSheet hbO\r\n"
"tH[}bgw肵ăZ[u邱Ƃł܂B\r\n"
"UserGraphic Z[u鎞 coerce.x, jpeged.r Ăяo܂B\r\n"
"----------------------------------------------------------------\r\n"
				);
				return	TRUE;
			}
			return	FALSE;
	}
	return	FALSE;
}


void
WindowMain( argc, argv )
int	argc;
char	**argv;
{
	int	x= 400, y= 0, pid, pct= -1;
	unsigned int	myinfo= 0;
	char	myname[]= "gv_save.win";
	WindowID	wp;

	argc= AnalyzeArgs( argc, argv, &x, &y, NULL, NULL );
	while( --argc ){
		++argv;
		if( (*argv)[0] == '-' && (*argv)[1] == 'U' ){
			char	table[]= "0123456789ABCDEF",
				*str= *argv + 2;
		    	while( *str ){
				int	i;
		   		for( i= 0; i < 16; i++ ){
					if( *str == table[i] ){
				    		myinfo<<= 4;
						myinfo+= i;
						break;
					}
				}
				if( i == 16 ){
					myinfo= 0;
					break;
				}
				++str;
			}
			break;
		}
	}
	for( pid= 0; pid= PidSearch( myname, pid+1 ); )	pct++;
	if( pct ){
		if( myinfo ){
			PidSendEvent( myname, (EventInfo*)myinfo, TRUE );
		}
		WindowConnectionClose();
	}else {
		wp= WindowTitleOpen( x, y, XSIZE, YSIZE, NULL, "",
						Close|Push, EventExec );
		if( myinfo )	WindowSendEvent( wp, (EventInfo*)myinfo );
	}
}
